/* example of loading a very big image a moving upon it */

#include <sys/types.h>  /* the following lines include the header files */
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libcd.h>
#include <kernel.h>
#include <stdio.h>
#include <string.h>

/* PAD constants */
#define PADLup     (1<<12)
#define PADLdown   (1<<14)
#define PADLleft   (1<<15)
#define PADLright  (1<<13)
#define PADRup     (1<< 4)
#define PADRdown   (1<< 6)
#define PADRleft   (1<< 7)
#define PADRright  (1<< 5)
#define PADi       (1<< 9)
#define PADj       (1<<10)
#define PADk       (1<< 8)
#define PADl       (1<< 3)
#define PADm       (1<< 1)
#define PADn       (1<< 2)
#define PADo       (1<< 0)
#define PADh       (1<<11)
#define PADL1      PADn
#define PADL2      PADo
#define PADR1      PADl
#define PADR2      PADm
#define PADstart   PADh
#define PADselect  PADk

#define OT_LENGTH       14              // OT lenght
#define PACKETMAX       (10000)         // max obj #
#define PACKETMAX2      (PACKETMAX*24)  // (psx voodoo, multiply by 24)
#define SCREEN_WIDTH  320               // width & height screen
#define SCREEN_HEIGHT 240

GsOT      WorldOrderingTable[2];                // OT handlers
GsOT_TAG  OrderingTable[2][1<<OT_LENGTH];	// OT
PACKET    GPUOutputPacket[2][PACKETMAX2];       // GPU packet work area

#define MAP_ADDR 0x80010000

static u_long PadData;
volatile u_char *bb0,*bb1;

GsSPRITE map;

void InitGraphics (void);
void InitSprite   (void);
void display      (void);

void main (void) {

     PadData = 0;
     PadInit(0);
     InitGraphics();
     InitSprite();

     while ((PadData & PADselect) == 0)  {
              if ((PadData & PADRright) > 0) map.x -= 3;
              if ((PadData & PADRleft)  > 0) map.x += 3;
              if ((PadData & PADRup)    > 0) map.y -= 2;
              if ((PadData & PADRdown)  > 0) map.y += 2;
              display();
                                         }
     ResetGraph(3);
                          }

void InitGraphics (void) {

      SetVideoMode(MODE_PAL);     // Pal video MODE
      // initialize graphic 
      GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsINTER|GsOFSGPU, 1, 0);
      // definition of display buffer
      GsDefDispBuff(0, 0, 0, SCREEN_HEIGHT);

      // Init OT
      WorldOrderingTable[0].length = OT_LENGTH;
      WorldOrderingTable[1].length = OT_LENGTH;
      WorldOrderingTable[0].org = OrderingTable[0];
      WorldOrderingTable[1].org = OrderingTable[1];
      GsClearOt(0,0,&WorldOrderingTable[0]);
      GsClearOt(0,0,&WorldOrderingTable[1]);

      }
// initialize sprite
void InitSprite (void)    {

        RECT rect;
        GsIMAGE timdata;

        // Get tim info
        GsGetTimInfo ((u_long *)(MAP_ADDR+4),&timdata);

        // Load images in frame buffer
        rect.x = timdata.px;     // coord x beginning of the TIM image
        rect.y = timdata.py;      // coord y beginning of the TIM image
        rect.w = timdata.pw;      // TIM width
        rect.h = timdata.ph;      // TIM height
        LoadImage(&rect,timdata.pixel); // load image into frame buffer

        map.attribute = 0x2000000; // 16 bit image
        map.x = 0;
        map.y = 0;
        map.w = timdata.pw;
        map.h = timdata.ph;
        map.tpage = GetTPage(1,0, timdata.px, timdata.py);
        map.u = 0;
        map.v = 0;
        map.r = map.g = map.b = 128;
        map.mx = map.my = 0;
        map.scalex = map.scaley = ONE;
        map.rotate = 0;

        DrawSync(0);

        }

void display (void) {

        int CurrentBuffer;

        CurrentBuffer = GsGetActiveBuff();
        GsSetWorkBase ((PACKET*)GPUOutputPacket[CurrentBuffer]);
        GsClearOt (0,0,&WorldOrderingTable[CurrentBuffer]);
        GsSortSprite (&map, &WorldOrderingTable[CurrentBuffer], 1);
        DrawSync (0);
        PadData = PadRead (1);
        VSync (0);
        GsSwapDispBuff();
        GsSortClear(0,0,0,&WorldOrderingTable[CurrentBuffer]);
        GsDrawOt(&WorldOrderingTable[CurrentBuffer]);

}

